commit 781890a0a437f072a6be18ceb37345bd650632b9
Author: Dan Shope <dshope@andrew.cmu.edu>
Date:   Wed Oct 19 14:03:10 2011 -0400

    Updated website structure, navigation, and graphics.

diff --git a/docs/www/colonyscout/contact.php b/docs/www/colonyscout/contact.php
index c061bb7..bb12987 100644
--- a/docs/www/colonyscout/contact.php
+++ b/docs/www/colonyscout/contact.php
@@ -49,6 +49,78 @@ if (file_exists($cacheFile)) //we can read this cache file back reduce database
 					<script type="text/javascript" src="http://disqus.com/forums/colonyscout/embed.js"></script><noscript>
 					<a href="http://disqus.com/forums/colonyscout/?url=ref">View the discussion thread.</a></noscript>
 				</div>
+
+				<div class="white-body text-box">
+					<h1>Scout Design Team</h1>
+					<p><span class="description">Meet the members of the Scout design team.</span>
+					<a href="http://www.twitter.com/colonyscout/" target="about:blank:" title="Colony Scout Twitter Feed">
+						<img id="team-twitter" src="/images/team_twitter.jpg"></a>
+					</p>
+					<div class="hr"></div>
+					
+					<div class="team-box">
+						<h2 class="blue">Dan</h2>
+						<img src="images/team_dan.jpg" alt="Dan, Project Manager, Colony Scout"/>
+						<p><em>Project Manager</em></p>
+						<p>Howdy! I'm a mechanical engineering student by day, and a roboticist by night. I make sure things 
+						are pixel perfect from our websites to SolidWorks CAD models. As manager of the Scout team, I oversee 
+						a talented group of engineers who make every design decision worthwhile.</p>
+					</div>
+					<div class="team-box">
+						<h2 class="blue">Kevin</h2>
+						<img src="images/team_kevin.jpg" alt="Kevin, Lead Electrical Engineer, Colony Scout"/>
+						<p><em>Lead Electrical Engineer</em></p>
+						<p>I am an electrical and computer engineering student specializing in computer hardware and firmware. 
+						My passion? Designing awesome embedded systems that you use everyday. I also enjoy naming boards after types of
+						flies. I designed the Scoutfly board as well as work with the Mechanical and OS team to provide the hardware 
+						needed for the robot.</p>
+					</div>
+					<div class="team-box" style="border-right:none;clear:right;">
+						<h2 class="blue">Brad</h2>
+						<img src="images/team_brad.jpg" alt="Brad, OS, Colony Scout"/>
+						<p><em>Operating System Master</em></p>
+						<p>Hi, I am a computer science student who loves robots! I lead the OS team and I'm also designing Scout's 
+						software architecture. I'm hoping to spread my love of robots by creating a system that is reliable and
+						easy to program and understand.</p>
+					</div>
+					
+					<div class="bot-gray"></div>
+					
+					<div class="team-box-small">
+						<h3>James</h3>
+						<img src="images/team_james.jpg" alt="James, Colony Scout"/>
+						<em>Tech Consultant</em>
+						<p>I consult on design issues, researched potential operating systems and localization module designs, 
+						and provided initial encouragement for the Colony Scout project.</p>
+					</div>
+					<div class="team-box-small">
+						<h3>Chris</h3>
+						<img src="images/team_chris.jpg" alt="Chris, BOM, Colony Scout"/>
+						<em>BOM/Wireless</em>
+						<p>I'm an electrical and computer engineering major designing some of the additional hardware for the Scout, 
+						including the BOM daughter board. I am also interested in software engineering on embedded systems, and I look 
+						forward to building and using this new platform.</p>
+					</div>	
+					<div class="team-box-small">
+						<h3>Rich</h3>
+						<img src="images/team_rich.jpg" alt="Rich, OS, Colony Scout"/>
+						<em>Operating System</em>
+						<p>I am the 1337 h4x0r who helps on the Scout's OS. In my spare time I enjoy keeping servers from exploding 
+						and bringing organizations into the social networking scene. Oh, also I <i>am</i> really a monkey.</p>
+					</div>
+					<div class="team-box-small" style="border:none;">
+						<h3>David</h3>
+						<img src="images/team_david.jpg" alt="David, Wireless Systems, Colony Scout"/>
+						<em>Wireless Systems</em>
+						<p>I'm a physics and computer science student, and 
+						dabble in robotics in my free time.  I manage the wireless communication 
+						subsystem both on the main board and as a bridge between the robots and 
+						the internet.</p>
+					</div>
+
+					<div class="bot-gray"></div>
+				</div>
+				
 				
 				<div class="white-body text-box">
 					<div class="hr"></div>