commit 0f5ac911084a6b4c0aa9e94f600e79054c1914e9
Author: Jess Chernak <jchernak@andrew.cmu.edu>
Date:   Sun Apr 27 23:59:04 2014 -0400

    started routing motor controllers on scoutshield board

diff --git a/scoutshield/scoutshield_v1.sch b/scoutshield/scoutshield_v1.sch
index b8d92b2..165d711 100644
--- a/scoutshield/scoutshield_v1.sch
+++ b/scoutshield/scoutshield_v1.sch
@@ -8601,9 +8601,9 @@ Source: http://www.vishay.com .. dcrcw.pdf</description>
 <label x="-20.32" y="17.78" size="1.778" layer="95"/>
 </segment>
 <segment>
-<wire x1="-83.82" y1="177.8" x2="-83.82" y2="175.26" width="0.1524" layer="91"/>
-<label x="-83.058" y="178.054" size="1.778" layer="95" rot="R90"/>
-<pinref part="JP4" gate="G$1" pin="3"/>
+<wire x1="-91.44" y1="177.8" x2="-91.44" y2="175.26" width="0.1524" layer="91"/>
+<label x="-90.678" y="178.054" size="1.778" layer="95" rot="R90"/>
+<pinref part="JP4" gate="G$1" pin="6"/>
 </segment>
 </net>
 <net name="MOTOR1_IN2/ENBL" class="0">
@@ -8613,9 +8613,9 @@ Source: http://www.vishay.com .. dcrcw.pdf</description>
 <label x="-20.32" y="12.7" size="1.778" layer="95"/>
 </segment>
 <segment>
-<wire x1="-86.36" y1="177.8" x2="-86.36" y2="175.26" width="0.1524" layer="91"/>
-<label x="-85.344" y="178.054" size="1.778" layer="95" rot="R90"/>
-<pinref part="JP4" gate="G$1" pin="4"/>
+<wire x1="-88.9" y1="177.8" x2="-88.9" y2="175.26" width="0.1524" layer="91"/>
+<label x="-87.884" y="178.054" size="1.778" layer="95" rot="R90"/>
+<pinref part="JP4" gate="G$1" pin="5"/>
 </segment>
 </net>
 <net name="MOTOR2_IN1/PHASE" class="0">
@@ -8625,9 +8625,9 @@ Source: http://www.vishay.com .. dcrcw.pdf</description>
 <label x="-20.32" y="7.62" size="1.778" layer="95"/>
 </segment>
 <segment>
-<wire x1="-88.9" y1="177.8" x2="-88.9" y2="175.26" width="0.1524" layer="91"/>
-<label x="-87.884" y="178.054" size="1.778" layer="95" rot="R90"/>
-<pinref part="JP4" gate="G$1" pin="5"/>
+<wire x1="-86.36" y1="177.8" x2="-86.36" y2="175.26" width="0.1524" layer="91"/>
+<label x="-85.344" y="178.054" size="1.778" layer="95" rot="R90"/>
+<pinref part="JP4" gate="G$1" pin="4"/>
 </segment>
 </net>
 <net name="MOTOR2_IN2/ENBL" class="0">
@@ -8637,9 +8637,9 @@ Source: http://www.vishay.com .. dcrcw.pdf</description>
 <label x="-20.32" y="2.54" size="1.778" layer="95"/>
 </segment>
 <segment>
-<wire x1="-91.44" y1="177.8" x2="-91.44" y2="175.26" width="0.1524" layer="91"/>
-<label x="-90.678" y="178.054" size="1.778" layer="95" rot="R90"/>
-<pinref part="JP4" gate="G$1" pin="6"/>
+<wire x1="-83.82" y1="177.8" x2="-83.82" y2="175.26" width="0.1524" layer="91"/>
+<label x="-83.058" y="178.054" size="1.778" layer="95" rot="R90"/>
+<pinref part="JP4" gate="G$1" pin="3"/>
 </segment>
 </net>
 <net name="N$4" class="0">
@@ -8697,9 +8697,9 @@ Source: http://www.vishay.com .. dcrcw.pdf</description>
 <label x="-20.32" y="-20.32" size="1.778" layer="95"/>
 </segment>
 <segment>
-<wire x1="-93.98" y1="177.8" x2="-93.98" y2="175.26" width="0.1524" layer="91"/>
-<label x="-93.218" y="178.054" size="1.778" layer="95" rot="R90"/>
-<pinref part="JP4" gate="G$1" pin="7"/>
+<wire x1="-111.76" y1="175.26" x2="-111.76" y2="177.8" width="0.1524" layer="91"/>
+<label x="-111.252" y="177.8" size="1.778" layer="95" rot="R90"/>
+<pinref part="JP3" gate="G$1" pin="2"/>
 </segment>
 </net>
 <net name="MOTOR3_IN2/ENBL" class="0">
@@ -8709,9 +8709,9 @@ Source: http://www.vishay.com .. dcrcw.pdf</description>
 <label x="-20.32" y="-25.4" size="1.778" layer="95"/>
 </segment>
 <segment>
-<wire x1="-96.52" y1="175.26" x2="-96.52" y2="177.8" width="0.1524" layer="91"/>
-<label x="-96.012" y="178.054" size="1.778" layer="95" rot="R90"/>
-<pinref part="JP4" gate="G$1" pin="8"/>
+<wire x1="-109.22" y1="175.26" x2="-109.22" y2="177.8" width="0.1524" layer="91"/>
+<label x="-108.458" y="177.8" size="1.778" layer="95" rot="R90"/>
+<pinref part="JP3" gate="G$1" pin="1"/>
 </segment>
 </net>
 <net name="MOTOR4_IN1/PHASE" class="0">
@@ -8721,9 +8721,9 @@ Source: http://www.vishay.com .. dcrcw.pdf</description>
 <label x="-20.32" y="-30.48" size="1.778" layer="95"/>
 </segment>
 <segment>
-<wire x1="-109.22" y1="175.26" x2="-109.22" y2="177.8" width="0.1524" layer="91"/>
-<label x="-108.458" y="177.8" size="1.778" layer="95" rot="R90"/>
-<pinref part="JP3" gate="G$1" pin="1"/>
+<wire x1="-96.52" y1="175.26" x2="-96.52" y2="177.8" width="0.1524" layer="91"/>
+<label x="-96.012" y="178.054" size="1.778" layer="95" rot="R90"/>
+<pinref part="JP4" gate="G$1" pin="8"/>
 </segment>
 </net>
 <net name="MOTOR4_IN2/ENBL" class="0">
@@ -8733,9 +8733,9 @@ Source: http://www.vishay.com .. dcrcw.pdf</description>
 <label x="-20.32" y="-35.56" size="1.778" layer="95"/>
 </segment>
 <segment>
-<wire x1="-111.76" y1="175.26" x2="-111.76" y2="177.8" width="0.1524" layer="91"/>
-<label x="-111.252" y="177.8" size="1.778" layer="95" rot="R90"/>
-<pinref part="JP3" gate="G$1" pin="2"/>
+<wire x1="-93.98" y1="177.8" x2="-93.98" y2="175.26" width="0.1524" layer="91"/>
+<label x="-93.218" y="178.054" size="1.778" layer="95" rot="R90"/>
+<pinref part="JP4" gate="G$1" pin="7"/>
 </segment>
 </net>
 <net name="N$6" class="0">